/*
 * jMap.java
 *
 * Created on May 31, 2004, 1:44 AM
 */

/**
 *
 * @author  Andrew T. Flowers
 */


import javax.swing.*;
import java.awt.*;

/**
 * This is the map display for the RainScatter program.  It uses extends a JLabel
 * to do custom painting (stations, paths, etc).
 */
public class StationsMap extends JLabel{
    RainScatter mainProgram;
    java.util.Vector stationVector;//
    
    public StationsMap(RainScatter rainScatter) {
        mainProgram = rainScatter;
        stationVector = new java.util.Vector();
        Cursor c = new java.awt.Cursor(java.awt.Cursor.CROSSHAIR_CURSOR);
        setCursor(c);
    }
    
    public void setStationList(java.util.Vector stationVector) {
        this.stationVector = stationVector; 
        this.repaint();
    }

    protected void paintComponent(Graphics g) {

        super.paintComponent(g);   //paint map in background
        
        Graphics2D g2d = (Graphics2D)g;
        int width = 1;
        g2d.setStroke(new BasicStroke(width));
        g.setColor(Color.YELLOW);
        for (int i = 0; i < stationVector.size(); i++) {
            Station s = (Station)(stationVector.get(i));
            String callsign = s.getCall();
            Point p = mainProgram.getPixelFromGrid(s.getGrid());
            g.drawLine(p.x, p.y-3, p.x, p.y+3);
            g.drawLine(p.x-3, p.y, p.x+3, p.y);
            
            g.drawString(callsign, p.x + 5, p.y - 5);
        }

        g.dispose();  //clean up
    }

}

